package at.ac.uibk.gitsearch.service.dto;

import com.fasterxml.jackson.annotation.JsonInclude;

import javax.validation.constraints.Email;
import javax.validation.constraints.Size;

/**
 * DTO representing users contained in metadata such
 * as creators, publishers, contributors
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
public class MetadataUserDTO {

    @Size(max = 254)
    private String name;

    @Size(max = 254)
    private String affiliation;

    @Email
    @Size(min = 5, max = 254)
    private String email;

    public MetadataUserDTO() {

    }

    public MetadataUserDTO(String name, String affiliation, String email) {
        this.name = name;
        this.affiliation = affiliation;
        this.email = email;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getAffiliation() {
        return affiliation;
    }

    public void setAffiliation(String affiliation) {
        this.affiliation = affiliation;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    @Override
    public String toString() {
        return "MetadataUserDTO{" +
            "name='" + name + '\'' +
            ", affiliation='" + affiliation + '\'' +
            ", email='" + email + '\'' +
            '}';
    }
}
